package digi.recipeManager;

import org.bukkit.*;
import org.bukkit.block.*;
import org.bukkit.entity.Player;
import org.bukkit.event.Event.Result;
import org.bukkit.event.*;
import org.bukkit.event.block.*;
import org.bukkit.event.inventory.*;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.world.*;
import org.bukkit.inventory.*;
import org.bukkit.inventory.Recipe;

import digi.recipeManager.data.*;

class Events implements Listener
{
	protected Events()
	{
		Main.pm.registerEvents(this, Main.plugin);
		
		for(final World world : Main.sv.getWorlds())
		{
			worldLoad(world);
		}
	}
	
	@EventHandler
	public void playerQuit(final PlayerQuitEvent event)
	{
		Recipes.playerPage.remove(event.getPlayer().getName());
	}
	
	@EventHandler(priority = EventPriority.LOW, ignoreCancelled = true)
	public void eventInventoryClick(final InventoryClickEvent event)
	{
		final Inventory inv = event.getInventory();
		
		if(inv == null)
			return;
		
		final InventoryHolder holder = inv.getHolder();
		
		if(holder == null || !(holder instanceof Furnace))
			return;
		
		final Player player = (Player)event.getWhoClicked();
		final ItemStack cursorItem = event.getCursor();
		
		if(cursorItem == null)
			return;
		
		switch(event.getRawSlot())
		{
			case 0: // INGREDIENT slot
			{
				if(!canCraft(player))
				{
					event.setResult(Result.DENY);
					return;
				}
				
				final Smelt recipe = Recipes.getSmeltRecipe(cursorItem);
				
				if(recipe == null)
					return;
				
				if(!recipe.usableBy(player))
					event.setResult(Result.DENY);
				
				return;
			}
			
			case 1: // FUEL slot
			{
				if(!canCraft(player))
				{
					event.setResult(Result.DENY);
					return;
				}
				
				final Fuel recipe = Recipes.getFuelRecipe(cursorItem);
				
				if(recipe == null)
					return;
				
				if(!recipe.usableBy(player))
					event.setResult(Result.DENY);
				
				return;
			}
		}
	}
	
	@SuppressWarnings("deprecation")
	@EventHandler(priority = EventPriority.LOW, ignoreCancelled = true)
	public void eventCraft(final CraftItemEvent event)
	{
		if(event.getCurrentItem() == null)
			return;
		
		final Recipe r = event.getRecipe();
		
		if(r == null)
			return;
		
		final ItemStack recipeResult = r.getResult();
		
		if(!Recipes.isCustomRecipe(recipeResult))
			return;
		
		final Player player = (Player)event.getWhoClicked();
		final boolean shiftClick = event.isShiftClick();
		
		// TODO: finish once CB with fix is recommended
		/*
		if(r instanceof ShapedRecipe)
		{
			final Craft recipe = Recipes.craft.get(recipeResult.getAmount());
			
			if(recipe == null)
				return;
			
			if(recipe.results.size() > 1)
			{
				if(shiftClick)
				{
					player.sendMessage(ChatColor.RED + "Can't shift+click recipes with multiple results!");
					event.setCancelled(true);
					return;
				}
				
				final Item result = recipe.getRandomResult();
				final ItemStack cursor = event.getCursor();
				
				if(result.type == 0)
				{
					System.out.print("DEBUG: result is air...");
					
					if(Main.cfgPrintFailure)
						player.sendMessage(ChatColor.RED + "Crafting recipe failed! " + ChatColor.GRAY + "(" + result.chance + "% failure chance)");
					
					ItemStack item;
					int amt;
					
					for(int i = 1; i < 9; i++)
					{
						item = event.getInventory().getItem(i);
						
						if(item != null)
						{
							if((amt = item.getAmount() - 1) > 0)
								item.setAmount(amt);
							else
								event.getInventory().clear(i);
						}
					}
					
					event.setResult(Result.ALLOW);
					event.setCancelled(true);
				}
				else
				{
					if(!result.equalsItemData(cursor))
					{
						System.out.print("DEBUG: differnt item, giving item to player and setting new item to cursor");
						
						giveItem(player, cursor);
						event.setCursor(result.getItemStack());
					}
					else
					{
						System.out.print("DEBUG: same item, updating item");
						
						event.setCurrentItem(result.getItemStack());
					}
				}
				
				return;
			}
		}
		else if(r instanceof ShapelessRecipe)
		{
			final Combine recipe = Recipes.combine.get(recipeResult.getAmount());
			
			if(recipe == null)
				return;
			
			if(recipe.results.size() > 1)
			{
				if(shiftClick)
				{
					player.sendMessage(ChatColor.RED + "Can't shift+click recipes with multiple results!");
					event.setCancelled(true);
					return;
				}
				
		//				final Item result = recipe.getRandomResult();
				
				return;
			}
		}
		*/
		
		if(shiftClick) // temp bugfix for Bukkit
		{
			Main.bs.scheduleSyncDelayedTask(Main.plugin, new Runnable()
			{
				@Override
				public void run()
				{
					player.updateInventory();
				}
			});
		}
		
		/*
		if(r instanceof ShapedRecipe)
		{
			final Craft recipe = Recipes.craft.get(craftResult.getAmount());
			
			if(recipe == null)
				return;
			
			if(recipe.chance < 100)
			{
				final int rand = new Random().nextInt(100);
				
				Main.debug("Craft item with chance of " + recipe.chance + "%, random num = " + rand);
				
				if(rand > recipe.chance)
				{
					final ItemStack cursor = event.getCursor();
					
					if(cursor != null && cursor.getAmount() > 0)
					{
						cursor.setAmount(cursor.getAmount() - 1);
						event.setCursor(cursor);
					}
					else
						event.setCursor(null);
					
					if(Main.cfgPrintFailure)
						player.sendMessage(ChatColor.RED + "Failed to craft recipe! " + ChatColor.GOLD + "(success chance: " + recipe.chance + "%)");
				}
			}
			
			final Inventory inv = event.getInventory();
			
			Main.debug("shiftclick = " + event.isShiftClick() + ", result amount = " + inv.getItem(0).getAmount());
			
			for(int i = 0; i < recipe.leftovers.length; i++)
			{
				if(recipe.leftovers[i] == null)
					continue;
				
				if(inv.getItem(i + 1) == null || inv.getItem(i + 1).getTypeId() == 0)
					inv.setItem(i + 1, recipe.leftovers[i].getItemStack());
				
				else
				{
					final HashMap<Integer, ItemStack> drop = player.getInventory().addItem(recipe.leftovers[i].getItemStack());
					
					if(drop.size() > 0)
					{
						final Location loc = player.getLocation();
						final World world = loc.getWorld();
						
						for(final Entry<Integer, ItemStack> entry : drop.entrySet())
						{
							world.dropItem(loc, entry.getValue());
						}
					}
				}
			}
		}
		else if(r instanceof ShapelessRecipe)
		{
			final Combine recipe = Recipes.combine.get(craftResult.getAmount());
			
			if(recipe == null)
				return;
			
			if(recipe.results.size() > 1)
			{
				// TODO: fix bug: get 2 items first time you succesfully craft after a failed one
				
				if(event.isShiftClick())
				{
					player.sendMessage(ChatColor.RED + "Can't shift+click recipes with multiple results!");
					event.setCancelled(true);
					return;
				}
				
				final int rand = new Random().nextInt(100);
				int chance = 0;
				Item result = null;
				
				for(final Item item : recipe.results)
				{
					if((chance += item.chance) > rand)
					{
						result = item;
						break;
					}
				}
				
				final ItemStack cursor = event.getCursor();
				
				if(result.type == 0)
				{
					if(Main.cfgPrintFailure)
						player.sendMessage(ChatColor.RED + "Crafting recipe failed! " + ChatColor.GRAY + "(" + result.chance + "% failure chance)");
					
					ItemStack item;
					int amt;
					
					for(int i = 1; i < 9; i++)
					{
						item = event.getInventory().getItem(i);
						
						if(item != null)
						{
							if((amt = item.getAmount() - 1) > 0)
								item.setAmount(amt);
							else
								event.getInventory().clear(i);
						}
					}
					
					event.setResult(Result.ALLOW);
					event.setCancelled(true);
				}
				else
				{
					if(!(cursor.getType() + ":" + cursor.getDurability()).equals(result.getMaterial() + ":" + result.data))
					{
						giveItem(player, cursor);
						event.setCursor(result.getItemStack());
					}
					else
						event.setCurrentItem(result.getItemStack());
				}
			}
		}
		*/
	}
	
	@EventHandler(priority = EventPriority.LOW, ignoreCancelled = true)
	public void eventPreCraft(final PrepareItemCraftEvent event)
	{
		final Player player = (Player)event.getView().getPlayer();
		
		if(!canCraft(player))
		{
			event.getInventory().setItem(0, null);
			return;
		}
		
		final Recipe craftedRecipe = event.getRecipe();
		
		if(craftedRecipe == null)
			return;
		
		final ItemStack craftedResult = craftedRecipe.getResult();
		
		if(craftedResult.getTypeId() != Main.recipeIndicatorItemId || craftedResult.getDurability() != Main.recipeIndicatorItemData)
			return;
		
		if(craftedRecipe instanceof ShapedRecipe)
		{
			final Craft recipe = Recipes.craft.get(craftedResult.getAmount());
			
			if(recipe == null)
				return;
			
			ItemStack result = null;
			
			if(recipe.usableBy(player))
				result = recipe.results.get(0).getItemStack(); // Display the first result item
				
			event.getInventory().setItem(0, result);
		}
		else if(craftedRecipe instanceof ShapelessRecipe)
		{
			final Combine recipe = Recipes.combine.get(craftedResult.getAmount());
			
			if(recipe == null)
				return;
			
			ItemStack result = null;
			
			if(recipe.usableBy(player))
				result = recipe.results.get(0).getItemStack(); // Display the first result item
				
			event.getInventory().setItem(0, result);
		}
	}
	
	@EventHandler(priority = EventPriority.LOW, ignoreCancelled = true)
	public void eventFurnaceSmelt(final FurnaceSmeltEvent event)
	{
		final Smelt recipe = Recipes.getSmeltRecipe(event.getSource());
		
		if(recipe == null)
			return;
		
		// special process for result AIR recipes
		if(recipe.result.type == 0)
		{
			event.setCancelled(true);
			
			final BlockState state = event.getBlock().getState();
			
			if(state instanceof Furnace)
			{
				final Furnace furnace = (Furnace)state;
				
				final ItemStack item = furnace.getInventory().getItem(0);
				
				item.setAmount(item.getAmount() - 1);
				
				if(item.getAmount() <= 0)
					furnace.getInventory().clear(0);
				else
					furnace.getInventory().setItem(0, item);
			}
		}
	}
	
	@EventHandler(ignoreCancelled = true)
	public void eventFurnaceBurn(final FurnaceBurnEvent event)
	{
		final Location loc = event.getBlock().getLocation();
		
		if(!Main.furnacesSmelting.containsKey(loc))
			Main.furnacesSmelting.put(loc, (double)0);
		
		final ItemStack item = event.getFuel();
		final Fuel fuel = Recipes.getFuelRecipe(item);
		
		if(fuel == null)
			return;
		
		event.setBurnTime(20 * fuel.getTime());
		event.setBurning(true);
	}
	
	private boolean canCraft(final Player player)
	{
		if(!player.hasPermission("recipemanager.craft"))
		{
			Main.printMessage(player, Lang.get("notify.nopermissionall"));
			return false;
		}
		
		return true;
	}
	
	/*
	@SuppressWarnings("deprecation")
	private void giveItem(final Player player, final ItemStack item)
	{
		player.getInventory().addItem(item);
		player.updateInventory();
		
		// TODO: drop excess items
	}
	*/
	
	// Monitor furnaces
	
	@EventHandler(priority = EventPriority.MONITOR, ignoreCancelled = true)
	public void eventBlockPlace(final BlockPlaceEvent event)
	{
		furnaceBlock(event.getBlock());
	}
	
	@EventHandler(priority = EventPriority.MONITOR, ignoreCancelled = true)
	public void eventBlockBreak(final BlockBreakEvent event)
	{
		furnaceBlock(event.getBlock());
	}
	
	@EventHandler(priority = EventPriority.MONITOR, ignoreCancelled = true)
	public void eventWorldLoad(final WorldLoadEvent event)
	{
		worldLoad(event.getWorld());
	}
	
	@EventHandler(priority = EventPriority.MONITOR, ignoreCancelled = true)
	public void eventChunkLoad(final ChunkLoadEvent event)
	{
		if(!event.isNewChunk())
			furnaceChunk(event.getChunk(), true);
	}
	
	@EventHandler(priority = EventPriority.MONITOR, ignoreCancelled = true)
	public void eventChunkUnload(final ChunkUnloadEvent event)
	{
		furnaceChunk(event.getChunk(), false);
	}
	
	private void furnaceBlock(final Block block)
	{
		final Material blockType = block.getType();
		
		if(blockType == Material.FURNACE || blockType == Material.BURNING_FURNACE)
			Main.furnacesSmelting.put(block.getLocation(), (double)0);
	}
	
	private void worldLoad(final World world)
	{
		final Chunk chunks[] = world.getLoadedChunks();
		
		for(final Chunk chunk : chunks)
			furnaceChunk(chunk, true);
	}
	
	private void furnaceChunk(final Chunk chunk, final boolean add)
	{
		if(chunk == null)
			return;
		
		final BlockState tileEnts[] = chunk.getTileEntities();
		
		if(tileEnts.length <= 0)
			return;
		
		for(final BlockState ent : tileEnts)
		{
			if(ent != null && ent instanceof Furnace)
			{
				if(add)
					Main.furnacesSmelting.put(ent.getBlock().getLocation(), (double)0);
				else
					Main.furnacesSmelting.remove(ent.getBlock().getLocation());
			}
		}
	}
}