package digi.recipeManager.data;

import java.util.HashMap;

import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemStack;

public class Item extends ItemData
{
	public int amount = 1;
	public int chance = 100;
	public HashMap<Enchantment, Integer> enchantments = new HashMap<Enchantment, Integer>();
	
	public Item(final int type)
	{
		super(type);
	}
	
	public Item(final int type, final int amount)
	{
		super(type);
		this.amount = amount;
	}
	
	public Item(final int type, final int amount, final short data)
	{
		super(type, data);
		this.amount = amount;
	}
	
	public Item(final int type, final int amount, final short data, final int chance)
	{
		super(type, data);
		this.amount = amount;
		this.chance = chance;
	}
	
	public Item(final ItemStack item)
	{
		super(item.getTypeId(), item.getDurability());
		amount = item.getAmount();
	}
	
	public ItemStack getItemStack()
	{
		final ItemStack item = new ItemStack(type, amount, data);
		item.addUnsafeEnchantments(enchantments);
		return item;
	}
	
	/*
	public boolean equalsItemData(final ItemStack itemStack)
	{
		// TODO: itemStack.getType().getMaxStackSize() ?
	
		return (itemStack.getTypeId() == type && itemStack.getDurability() == data);
	}
	*/
	
	public boolean compareItemStack(final ItemStack item)
	{
		if(item == null)
			return false;
		
		final int dur = item.getDurability();
		
		return (item.getTypeId() == type && (dur == -1 || dur == data));
	}
	
	public boolean compareItemData(final ItemData item)
	{
		return (item != null && item.type == type && (item.data == -1 || item.data == data));
	}
	
	public String printAuto()
	{
		final int enchants = enchantments.size();
		
		return (amount > 1 ? amount + "x " : "") + printItemData() + (enchants > 0 ? " (" + enchants + " enchant" + (enchants == 1 ? "" : "s") + ")" : "") + (chance < 100 ? " " + chance + "% chance" : "");
	}
	
	@Override
	public String toString()
	{
		return printAuto();
	}
}